# Assumptions - Basic Computer Knowledge

We've tried to be thorough with the documentation so you can get set up and running without too much difficulty. However, we've left out several base level steps, assuming you're familiar with them or can 'Google them' to figure out how to do it. This is mostly related to file and folder system management, installing programs, and some basic terminal commands. You may or may not already have experience with this so we've tried here to give resources to some of the common ones.

A non-exhaustive list of things you'll likely have to do but we haven't given explicit instructions for:

- install programs (and be able to find WHERE you installed them to - so you can set the PATH later)
	- know which extension to use for installing on your particular machine
		- i.e. .tar.gz vs .exe
		- knowing whether you have a 32-bit or 64-bit machine
- add to / update your system PATH (so a program can be run from any folder via terminal / command prompt)
- access / find / open files on your computer
	- open with your text editor
		- set your text editor to the default program to open these file types
- basic command prompt / linux commands such as:
	- `cd` to change directories
		- `cd ../` to go back a directory
		- `TAB` to autocomplete
	- copy and paste to command prompt / terminal (varies by command window program - i.e. `Shift+Insert` for Git Bash on Windows)
		- you typically can also press 'ALT' and/or left-click the top-left icon on the command window and select copy/paste from the menu
- copy and paste
- accessing and saving images from the Internet (i.e. right-click then click 'save image as' or 'save image URL')
	- saving / moving the image to a particular folder on your computer
	- figuring out the height and width of the image
- Browser 'inspect element' to see the source code (HTML, CSS, Javascript) of a web page
	- i.e. Firebug for Firefox and/or right-click on an element on the page and click 'Inspect Element'

